package main

import (
	"strings"
	"testing"
)

func TestSplit(t *testing.T) {
	for _, x := range []struct {
		input string
		want  string
	}{
		{"[[[[0,7],4],[15,[0,13]]],[1,1]]", "[[[[0,7],4],[[7,8],[0,13]]],[1,1]]"},
		{"[[[[0,7],4],[[7,8],[0,13]]],[1,1]]", "[[[[0,7],4],[[7,8],[0,[6,7]]]],[1,1]]"},
	} {
		n, _ := parseNumber(x.input)
		n.split()
		if have := n.String(); have != x.want {
			t.Errorf("%s have %s want %s\n", x.input, have, x.want)
		}
	}
}

func TestExplode(t *testing.T) {
	for _, x := range []struct {
		input string
		want  string
	}{
		{"[[[[[9,8],1],2],3],4]", "[[[[0,9],2],3],4]"},
		{"[7,[6,[5,[4,[3,2]]]]]", "[7,[6,[5,[7,0]]]]"},
		{"[[6,[5,[4,[3,2]]]],1]", "[[6,[5,[7,0]]],3]"},
		{"[[3,[2,[1,[7,3]]]],[6,[5,[4,[3,2]]]]]", "[[3,[2,[8,0]]],[9,[5,[4,[3,2]]]]]"},
		{"[[3,[2,[8,0]]],[9,[5,[4,[3,2]]]]]", "[[3,[2,[8,0]]],[9,[5,[7,0]]]]"},
		{"[[[[[4,3],4],4],[7,[[8,4],9]]],[1,1]]", "[[[[0,7],4],[7,[[8,4],9]]],[1,1]]"},
		{"[[[[0,7],4],[7,[[8,4],9]]],[1,1]]", "[[[[0,7],4],[15,[0,13]]],[1,1]]"},
	} {
		n, _ := parseNumber(x.input)
		n.explode()
		if have := n.String(); have != x.want {
			t.Errorf("%s have %s want %s\n", x.input, have, x.want)
		}
	}
}

func TestReduce(t *testing.T) {
	for _, x := range []struct {
		input string
		want  string
	}{
		{"[[[[[4,3],4],4],[7,[[8,4],9]]],[1,1]]", "[[[[0,7],4],[[7,8],[6,0]]],[8,1]]"},
	} {
		n, _ := parseNumber(x.input)
		n.reduce()
		if have := n.String(); have != x.want {
			t.Errorf("%s have %s want %s\n", x.input, have, x.want)
		}
	}
}

func TestAdd(t *testing.T) {
	for _, x := range []struct {
		input string
		want  string
	}{
		{"[[[[4,3],4],4],[7,[[8,4],9]]]\n[1,1]\n", "[[[[0,7],4],[[7,8],[6,0]]],[8,1]]"},
		{"[1,1]\n[2,2]\n[3,3]\n[4,4]\n", "[[[[1,1],[2,2]],[3,3]],[4,4]]"},
		{"[1,1]\n[2,2]\n[3,3]\n[4,4]\n[5,5]\n", "[[[[3,0],[5,3]],[4,4]],[5,5]]"},
		{"[1,1]\n[2,2]\n[3,3]\n[4,4]\n[5,5]\n[6,6]\n", "[[[[5,0],[7,4]],[5,5]],[6,6]]"},
		{"[[[0,[4,5]],[0,0]],[[[4,5],[2,6]],[9,5]]]\n[7,[[[3,7],[4,3]],[[6,3],[8,8]]]]\n",
			"[[[[4,0],[5,4]],[[7,7],[6,0]]],[[8,[7,7]],[[7,9],[5,0]]]]"},
		{`[[[0,[4,5]],[0,0]],[[[4,5],[2,6]],[9,5]]]
[7,[[[3,7],[4,3]],[[6,3],[8,8]]]]
[[2,[[0,8],[3,4]]],[[[6,7],1],[7,[1,6]]]]
[[[[2,4],7],[6,[0,5]]],[[[6,8],[2,8]],[[2,1],[4,5]]]]
[7,[5,[[3,8],[1,4]]]]
[[2,[2,2]],[8,[8,1]]]
[2,9]
[1,[[[9,3],9],[[9,0],[0,7]]]]
[[[5,[7,4]],7],1]
[[[[4,2],2],6],[8,7]]
`, "[[[[8,7],[7,7]],[[8,6],[7,7]]],[[[0,7],[6,6]],[8,7]]]"},
	} {
		numbers, _ := parse(strings.NewReader(x.input))
		if have := sum(numbers).String(); have != x.want {
			t.Errorf("%s have %s want %s\n", x.input, have, x.want)
		}
	}
}

func TestMagnitude(t *testing.T) {
	for _, x := range []struct {
		input string
		want  int
	}{
		{"[[1,2],[[3,4],5]]", 143},
		{"[[[[0,7],4],[[7,8],[6,0]]],[8,1]]", 1384},
		{"[[[[1,1],[2,2]],[3,3]],[4,4]]", 445},
		{"[[[[3,0],[5,3]],[4,4]],[5,5]]", 791},
		{"[[[[5,0],[7,4]],[5,5]],[6,6]]", 1137},
		{"[[[[8,7],[7,7]],[[8,6],[7,7]]],[[[0,7],[6,6]],[8,7]]]", 3488},
	} {
		number, _ := parseNumber(x.input)
		if have := number.magnitude(); have != x.want {
			t.Errorf("%s have %d want %d\n", x.input, have, x.want)
		}
	}
}

func TestSample(t *testing.T) {
	numbers, _ := parse(
		strings.NewReader(`[[[0,[5,8]],[[1,7],[9,6]]],[[4,[1,2]],[[1,4],2]]]
[[[5,[2,8]],4],[5,[[9,9],0]]]
[6,[[[6,2],[5,6]],[[7,6],[4,7]]]]
[[[6,[0,7]],[0,9]],[4,[9,[9,0]]]]
[[[7,[6,4]],[3,[1,3]]],[[[5,5],1],9]]
[[6,[[7,3],[3,2]]],[[[3,8],[5,7]],4]]
[[[[5,4],[7,7]],8],[[8,3],8]]
[[9,3],[[9,9],[6,[4,9]]]]
[[2,[[7,7],7]],[[5,8],[[9,3],[0,2]]]]
[[[[5,2],5],[8,[3,7]]],[[5,[7,5]],[4,4]]]
`))

	const want = "[[[[6,6],[7,6]],[[7,7],[7,0]]],[[[7,7],[7,7]],[[7,8],[9,9]]]]"

	result := sum(numbers)
	if have := result.String(); have != want {
		t.Errorf("result: want %s have %s\n", want, have)
	}

	const magnitude = 4140
	if mag := result.magnitude(); mag != magnitude {
		t.Errorf("magnitude: want %d have %d\n", magnitude, mag)
	}
}
